#include <iostream>
#include "averageFocusMethod.h"

#define sq(x) ((x) * (x))

/**
 * @file ŤʿѾΥˡμ
 * @brief ŤʿѾΥˡǾΥ׻
 * @param F ù
 * @param f ξΥ
 * @param f1 f2 Υ
 * @author Kento YAMADA
 * @date 2009.09.30
 */
void averageFocusMethod(const CvMat *F,
                       const double f,
                       double &f1,
                       double &f2) {

  /* {{{ Υ׻ɬפʥѥ᡼η׻ */
  CvMat *k = cvCreateMat(3, 1, CV_64FC1);
  CvMat *vecTmp = cvCreateMat(3, 1, CV_64FC1);
  CvMat *matTmp = cvCreateMat(3, 3, CV_64FC1);
  cvmSet(k, 0, 0, 0.0);
  cvmSet(k, 1, 0, 0.0);
  cvmSet(k, 2, 0, 1.0);

  CvMat *svdW = cvCreateMat(3, 3, CV_64FC1);
  CvMat *svdU = cvCreateMat(3, 3, CV_64FC1);
  CvMat *svdV = cvCreateMat(3, 3, CV_64FC1);
  cvmMulTransposed(F, matTmp, 0);
  cvSVD(matTmp, svdW, svdU, svdV);
  CvMat *e = cvCreateMat(3, 1, CV_64FC1);
  for(int i = 0; i < 3; i++) {
    cvmSet(e, i, 0, cvmGet(svdU, i, 2));
  }
  cvNormalize(e, e);

  cvmMulTransposed(F, matTmp, 1);
  cvSVD(matTmp, svdW, svdU, svdV);
  CvMat *ep = cvCreateMat(3, 1, CV_64FC1);
  for(int i = 0; i < 3; i++) {
    cvmSet(ep, i, 0, cvmGet(svdU, i, 2));
  }
  cvNormalize(ep, ep);

	cvmMul(F, k, vecTmp);
  double Fk  = cvNorm(vecTmp);
  double Fk2 = sq(Fk);
 
	cvTranspose(F, matTmp);
  cvmMul(matTmp, k, vecTmp);
  double Ftk  = cvNorm(vecTmp);
  double Ftk2 = sq(Ftk);

	cvmMulTransposed(F, matTmp, 0);
  cvmMul(matTmp, F, matTmp);
  cvmMul(matTmp, k, vecTmp);
  double kFFtFk = cvDotProduct(k, vecTmp);

  cvmMul(F, k, vecTmp);
  double kFk = cvDotProduct(k, vecTmp);

	cvCrossProduct(e, k, vecTmp);
  double ek2 = sq(cvNorm(vecTmp));

	cvCrossProduct(ep, k, vecTmp);
  double epk2 = sq(cvNorm(vecTmp));
  /* }}} */

  /* {{{ Ƚ */
  double condition = 0.1 * ((Fk > Ftk) ? Ftk : Fk) / f;
  if(fabs(kFk) < condition) {
    std::cerr << "# ERROR : ǤϤޤ" << std::endl;
    f1 = f2 = f;
    return;
  }
  /* }}} */

  /* {{{ Bougnoux μη׻ */
  double xi  = (Fk2 - ((kFFtFk * epk2) / kFk)) / (epk2 * Ftk2 - sq(kFk));
  double eta = (Ftk2 - ((kFFtFk * ek2) / kFk)) / (ek2 * Fk2 - sq(kFk));
  /* }}} Bougnoux μη׻ */

  /* {{{ إη׻ */
  double H11 = (2.0 * sq(sq(kFk)) * sq(eta)) + (4.0 * sq(kFk) * Ftk2 * eta) + (2.0 * sq(Ftk2)) - sq((sq(kFk) * eta) + Ftk2);
  double H22 = (2.0 * sq(sq(kFk)) * sq(xi))  + (4.0 * sq(kFk) * Fk2  * xi)  + (2.0 * sq(Fk2))  - sq((sq(kFk) * xi) + Fk2);
  double H12 = (4.0 * sq(sq(kFk)) * xi * eta) + (4.0 * sq(kFk) * ((Ftk2 * xi) + (Fk2 * eta))) + (4.0 * kFk * kFFtFk)
             - ((sq(kFk) * xi + Fk2) * (sq(kFk) * eta + Ftk2))
             - (sq(kFk) * (sq(kFk) * xi * eta + Ftk2 * xi + Fk2 * eta + sq(cvNorm(F))));
  /* }}} */

  /* {{{ ŤʿѤη׻ */
  xi = eta = (((H11 + H12) * xi) + ((H22 + H12) * eta)) / (H11 + 2.0 * H12 + H22);
  /* }}} */

  /* {{{ Υӽ */
  double inSqrt1 = 1.0 + xi;
  double inSqrt2 = 1.0 + eta;
  if(inSqrt1 < 0.0 || inSqrt2 < 0.0) {
    std::cerr << "# ERROR : Υ" << std::endl;
    f1 = f2 = f;
  } else {
    f1 = f / sqrt(inSqrt1);
    f2 = f / sqrt(inSqrt2);
  }
  /* }}} */

  /* {{{ Ѥ CvMat ʤɤγ */
  cvReleaseMat(&k);
  cvReleaseMat(&vecTmp);
  cvReleaseMat(&matTmp);
  cvReleaseMat(&svdW);
  cvReleaseMat(&svdU);
  cvReleaseMat(&svdV);
  cvReleaseMat(&e);
  cvReleaseMat(&ep);
  /* }}} */
}
