#include <iostream>
#include "calcMotionParameters.h"


/* --------------------------------------------------------------
   ------------------ ꡼Х ----------------------
   ս 1

   ر ʳظ
    ͺ
*/


/**
 * @file αưѥ᡼η׻Υإå
 * @brief αưѥ᡼η׻
 * @param F ù
 * @param f1 f2 Υ
 * @param f ξΥ
 * @param x1 x2 бǡ
 * @param N бǡο
 * @param t ֤¿
 * @param R ֤βž
 * @author Kento YAMADA
 * @date 2009.09.30
 */
void calcMotionParameters(const CvMat *F,
                          const double f1,
                          const double f2,
                          const double f,
                          const CvMat *x1,
                          const CvMat *x2,
                          const int N,
                          CvMat **t,
                          CvMat **R) {

  /* {{{ ܹ E η׻ */
  CvMat *E = cvCreateMat(3, 3, CV_64FC1);
  CvMat *matTmp1 = cvCreateMat(3, 3, CV_64FC1);
  CvMat *matTmp2 = cvCreateMat(3, 3, CV_64FC1);
  cvSetZero(matTmp1);
  cvmSet(matTmp1, 0, 0, 1.0);
  cvmSet(matTmp1, 1, 1, 1.0);
  cvmSet(matTmp1, 2, 2, f / f1);
  cvmMul(matTmp1, F, matTmp2);
  cvmSet(matTmp1, 2, 2, f / f2);
  cvmMul(matTmp2, matTmp1, E);
  /* }}} */

	/* {{{ ֤¿ t η׻ */
  cvmMulTransposed(E, matTmp1, 0);
  CvMat *svdW = cvCreateMat(3, 3, CV_64FC1);
  CvMat *svdU = cvCreateMat(3, 3, CV_64FC1);
  CvMat *svdV = cvCreateMat(3, 3, CV_64FC1);
  cvSVD(matTmp1, svdW, svdU, svdV);
  for(int i = 0; i < 3; i++) {
    cvmSet(*t, i, 0, cvmGet(svdU, i, 2));
  }
  cvNormalize(*t, *t);
	/* }}} */

  /* {{{ бȤ٥ȥѴ */
  CvMat **xv1 = new CvMat* [N];
  CvMat **xv2 = new CvMat* [N];
  for(int i = 0; i < N; i++) {
    xv1[i] = cvCreateMat(3, 1, CV_64FC1);
    xv2[i] = cvCreateMat(3, 1, CV_64FC1);
    cvmSet(xv1[i], 0, 0, cvmGet(x1, i, 0) / f1);
    cvmSet(xv1[i], 1, 0, cvmGet(x1, i, 1) / f1);
    cvmSet(xv1[i], 2, 0, 1.0);
    cvmSet(xv2[i], 0, 0, cvmGet(x2, i, 0) / f1);
    cvmSet(xv2[i], 1, 0, cvmGet(x2, i, 1) / f1);
    cvmSet(xv2[i], 2, 0, 1.0);
  }
  /* }}} */

  /* {{{ ¿ʥ٥ȥ t Ĵ */
  double condition = 0.0;
  CvMat *vecTmp1 = cvCreateMat(3, 1, CV_64FC1);
  CvMat *vecTmp2 = cvCreateMat(3, 1, CV_64FC1);
  for(int i = 0; i < N; i++) {
    cvCrossProduct(*t, xv1[i], vecTmp1);
    cvmMul(E, xv2[i], vecTmp2);
    condition += cvDotProduct(vecTmp1, vecTmp2);
  }
  if(condition < 0.0) {
    for(int i = 0; i < 3; i++) {
      cvmSet(*t, i, 0, -1 * cvmGet(*t, i, 0));
    }
  }
  /* }}} */

  /* {{{  -txE ðʬ */
  CvMat *vecTmp3 = cvCreateMat(3, 1, CV_64FC1);
  for(int i = 0; i < 3; i++) {
    cvmSet(vecTmp1, i, 0, -1 * cvmGet(*t, i, 0));
  }
  for(int i = 0; i < 3; i++) {
    for(int j = 0; j < 3; j++) {
      cvmSet(vecTmp2, j, 0, cvmGet(E, j, i));
    }
    cvCrossProduct(vecTmp1, vecTmp2, vecTmp3);
    for(int j = 0; j < 3; j++) {
      cvmSet(matTmp1, j, i, cvmGet(vecTmp3, j, 0));
    }
  }
  cvSVD(matTmp1, svdW, svdU, svdV);
  /* }}} */

  /* {{{ ֤βžη׻ */
  CvMat *Vt = cvCreateMat(3, 3, CV_64FC1);
  cvTranspose(svdV, Vt);
  cvSetIdentity(matTmp1);
  cvmMul(svdU, Vt, matTmp2);
  cvmSet(matTmp1, 2, 2, cvmDet(matTmp2));
  cvmMul(svdU, matTmp1, matTmp1);
  cvmMul(matTmp1, Vt, *R);
  /* }}} */

  /* {{{ Ѥ CvMat γ */
  cvReleaseMat(&E);
  cvReleaseMat(&matTmp1);
  cvReleaseMat(&matTmp2);
  cvReleaseMat(&svdW);
  cvReleaseMat(&svdU);
  cvReleaseMat(&svdV);
  cvReleaseMat(&vecTmp1);
  cvReleaseMat(&vecTmp2);
  cvReleaseMat(&vecTmp3);
  cvReleaseMat(&Vt);


  // --------------------------------------------------------------
  // ------------------ ꡼Х ----------------------
  // β
  for (int i = 0; i < N; i++)
  {
	  cvReleaseMat(&xv1[i]);
	  cvReleaseMat(&xv2[i]);
  }
  // --------------------------------------------------------------
  

  delete [] xv1;
  delete [] xv2;
  /* }}} */
}
