/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define CMDLINE_PARSER_PACKAGE "3DRec_opt"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION "1.0.0"
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * input_file_arg;	/**< @brief бȤǼƤե(XYɸ).  */
  char * input_file_orig;	/**< @brief бȤǼƤե(XYɸ) original value given at command line.  */
  const char *input_file_help; /**< @brief бȤǼƤե(XYɸ) help description.  */
  double default_focus_arg;	/**< @brief ξΥ (default='600.0').  */
  char * default_focus_orig;	/**< @brief ξΥ original value given at command line.  */
  const char *default_focus_help; /**< @brief ξΥ help description.  */
  double optimize_threshold_arg;	/**< @brief бμ«Ƚ (default='1e-4').  */
  char * optimize_threshold_orig;	/**< @brief бμ«Ƚ original value given at command line.  */
  const char *optimize_threshold_help; /**< @brief бμ«Ƚ help description.  */
  double efns_threshold_arg;	/**< @brief ùι (EFNSˡ) μ«Ƚ (default='1e-6').  */
  char * efns_threshold_orig;	/**< @brief ùι (EFNSˡ) μ«Ƚ original value given at command line.  */
  const char *efns_threshold_help; /**< @brief ùι (EFNSˡ) μ«Ƚ help description.  */
  char * focus_method_arg;	/**< @brief Υ׻ˡ (default='Average').  */
  char * focus_method_orig;	/**< @brief Υ׻ˡ original value given at command line.  */
  const char *focus_method_help; /**< @brief Υ׻ˡ help description.  */
  char * fundamental_file_arg;	/**< @brief ùν.  */
  char * fundamental_file_orig;	/**< @brief ùν original value given at command line.  */
  const char *fundamental_file_help; /**< @brief ùν help description.  */
  char * camera_file_arg;	/**< @brief ѥ᡼ν.  */
  char * camera_file_orig;	/**< @brief ѥ᡼ν original value given at command line.  */
  const char *camera_file_help; /**< @brief ѥ᡼ν help description.  */
  char * three_d_file_arg;	/**< @brief 3 ν.  */
  char * three_d_file_orig;	/**< @brief 3 ν original value given at command line.  */
  const char *three_d_file_help; /**< @brief 3 ν help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int input_file_given ;	/**< @brief Whether input-file was given.  */
  unsigned int default_focus_given ;	/**< @brief Whether default-focus was given.  */
  unsigned int optimize_threshold_given ;	/**< @brief Whether optimize-threshold was given.  */
  unsigned int efns_threshold_given ;	/**< @brief Whether efns-threshold was given.  */
  unsigned int focus_method_given ;	/**< @brief Whether focus-method was given.  */
  unsigned int fundamental_file_given ;	/**< @brief Whether fundamental-file was given.  */
  unsigned int camera_file_given ;	/**< @brief Whether camera-file was given.  */
  unsigned int three_d_file_given ;	/**< @brief Whether three-d-file was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char * const *argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
