#include <iostream>
#include "efnsMethod.h"

#define sq(x) ((x) * (x))

/**
 * @file EFNS μ
 * @brief EFNS Ѥƴù򹹿
 * @param xi 9 ٥ȥ
 * @param V 9x9 
 * @param u ùɽ 9 ٥ȥ
 * @param efnsThd «ȽѤ
 */
void efnsMethod(CvMat **xi,
                CvMat **V,
                CvMat **u,
                const int N,
                const double efnsThd) {

  /* {{{ 9x9  M  L η׻ */
  CvMat *M = cvCreateMat(9, 9, CV_64FC1);
  CvMat *L = cvCreateMat(9, 9, CV_64FC1);
  CvMat *MTmp = cvCreateMat(9, 9, CV_64FC1);
  CvMat *LTmp = cvCreateMat(9, 9, CV_64FC1);
  CvMat *uTmp = cvCreateMat(9, 1, CV_64FC1);
  CvMat *IdMat = cvCreateMat(9, 9, CV_64FC1);
  CvMat *up = cvCreateMat(9, 1, CV_64FC1);
  double uVu, uxi;
  double err;
  CvMat *ud = cvCreateMat(9, 1, CV_64FC1);
  CvMat *X = cvCreateMat(9, 9, CV_64FC1);
  CvMat *Y = cvCreateMat(9, 9, CV_64FC1);
  CvMat *svdW = cvCreateMat(9, 9, CV_64FC1);
  CvMat *svdU = cvCreateMat(9, 9, CV_64FC1);
  CvMat *svdV = cvCreateMat(9, 9, CV_64FC1);
  CvMat *v1 = cvCreateMat(9, 1, CV_64FC1);
  CvMat *v2 = cvCreateMat(9, 1, CV_64FC1);
  CvMat *uh = cvCreateMat(9, 1, CV_64FC1);
  CvMat *uv1v1 = cvCreateMat(9, 1, CV_64FC1);
  CvMat *uv2v2 = cvCreateMat(9, 1, CV_64FC1);
	
	do {
    cvSetZero(M);
    cvSetZero(L);
    for(int i = 0; i < N; i++) {
      cvmMul(V[i], *u, uTmp);
      uVu = cvDotProduct(*u, uTmp);
      cvmMulTransposed(xi[i], MTmp, 0);
      cvSetIdentity(IdMat, cvScalar(1.0/uVu));
      cvmMul(IdMat, MTmp, MTmp);
      cvmAdd(M, MTmp, M);
  
      uxi = cvDotProduct(*u, xi[i]);
      cvSetIdentity(IdMat, cvScalar(sq(uxi)));
      cvmMul(IdMat, V[i], LTmp);
      cvSetIdentity(IdMat, cvScalar(1.0/sq(uVu)));
      cvmMul(IdMat, LTmp, LTmp);
      cvmAdd(L, LTmp, L);
    }
    /* }}} */
  
    /* {{{ 9 ٥ȥ ud  9x9  Pu η׻ */
    cvmSet(ud, 0, 0, cvmGet(*u, 4, 0) * cvmGet(*u, 8, 0) - cvmGet(*u, 7, 0) * cvmGet(*u, 5, 0));
    cvmSet(ud, 1, 0, cvmGet(*u, 5, 0) * cvmGet(*u, 6, 0) - cvmGet(*u, 8, 0) * cvmGet(*u, 3, 0));
    cvmSet(ud, 2, 0, cvmGet(*u, 3, 0) * cvmGet(*u, 7, 0) - cvmGet(*u, 6, 0) * cvmGet(*u, 4, 0));
    cvmSet(ud, 3, 0, cvmGet(*u, 7, 0) * cvmGet(*u, 2, 0) - cvmGet(*u, 1, 0) * cvmGet(*u, 8, 0));
    cvmSet(ud, 4, 0, cvmGet(*u, 8, 0) * cvmGet(*u, 0, 0) - cvmGet(*u, 2, 0) * cvmGet(*u, 6, 0));
    cvmSet(ud, 5, 0, cvmGet(*u, 6, 0) * cvmGet(*u, 1, 0) - cvmGet(*u, 0, 0) * cvmGet(*u, 7, 0));
    cvmSet(ud, 6, 0, cvmGet(*u, 1, 0) * cvmGet(*u, 5, 0) - cvmGet(*u, 4, 0) * cvmGet(*u, 2, 0));
    cvmSet(ud, 7, 0, cvmGet(*u, 2, 0) * cvmGet(*u, 3, 0) - cvmGet(*u, 5, 0) * cvmGet(*u, 0, 0));
    cvmSet(ud, 8, 0, cvmGet(*u, 0, 0) * cvmGet(*u, 4, 0) - cvmGet(*u, 3, 0) * cvmGet(*u, 1, 0));
    cvNormalize(ud, ud);
    cvSetIdentity(IdMat, cvScalar(1.0));
    CvMat *Pu = cvCreateMat(9, 9, CV_64FC1);
    cvmMulTransposed(ud, Pu, 0);
    cvmSub(IdMat, Pu, Pu);
    /* }}} */
  
    /* {{{ 9x9  X  Y ׻ */
    cvmSub(M, L, X);
    cvmMul(Pu, X, Y);
    cvmMul(Y, Pu, Y);
    /* }}} */
  
    /* {{{  Y ξĤθͭͤбͭ٥ȥ v1  v2 η׻ */
    cvSVD(Y, svdW, svdU, svdV);
    for(int i = 0; i < 9; i++) {
      cvmSet(v1, i, 0, cvmGet(svdU, i, 8));
      cvmSet(v2, i, 0, cvmGet(svdU, i, 7));
    }
    /* }}} */
  
    /* {{{ 9 ٥ȥ uh η׻ */
    double uv1, uv2;
    uv1 = cvDotProduct(*u, v1);
    uv2 = cvDotProduct(*u, v2);
    cvSetIdentity(IdMat, cvScalar(uv1));
    cvmMul(IdMat, v1, uv1v1);
    cvSetIdentity(IdMat, cvScalar(uv2));
    cvmMul(IdMat, v2, uv2v2);
    cvmAdd(uv1v1, uv2v2, uh);
    /* }}} */
  
    /* {{{ 9 ٥ȥ up η׻ */
    cvmMul(Pu, uh, up);
    cvNormalize(up, up);
    /* }}} */
  
    /* {{{ «ȽѤθη׻ȴùι */
    cvmSub(up, *u, uTmp);
    err = cvNorm(uTmp);
    cvmAdd(*u, up, *u);
    cvNormalize(*u, *u);
    /* }}} */
  } while( err >= efnsThd);

  /* {{{ Ŭʴù */
  for(int i = 0; i < 9; i++) {
    cvmSet(*u, i, 0, cvmGet(up, i, 0));
	}
  /* }}} */

  /* {{{ Ѥ CvMat ʤɤγ*/
  cvReleaseMat(&M);
  cvReleaseMat(&L);
  cvReleaseMat(&MTmp);
  cvReleaseMat(&LTmp);
  cvReleaseMat(&uTmp);
  cvReleaseMat(&IdMat);
  cvReleaseMat(&up);
  cvReleaseMat(&ud);
  cvReleaseMat(&X);
  cvReleaseMat(&Y);
  cvReleaseMat(&svdW);
  cvReleaseMat(&svdU);
  cvReleaseMat(&svdV);
  cvReleaseMat(&v1);
  cvReleaseMat(&v2);
  cvReleaseMat(&uh);
  cvReleaseMat(&uv1v1);
  cvReleaseMat(&uv2v2);
  /* }}} */
}
