#include <iostream>
#include "freeFocusMethod.h"

#define sq(x) ((x) * (x))

/**
 * @file ͳΥˡΥإå
 * @brief ͳΥˡǾΥ׻
 * @param F ù
 * @param f ξΥ
 * @param f1 f2 Υ
 * @author Kento YAMADA
 * @date 2009.09.30
 */
void freeFocusMethod(const CvMat *F,
                     const double f,
                     double &f1,
                     double &f2) {

  /* {{{ Υ׻ɬפʥѥ᡼η׻ */
  CvMat *k = cvCreateMat(3, 1, CV_64FC1);
  CvMat *vecTmp = cvCreateMat(3, 1, CV_64FC1);
  CvMat *matTmp = cvCreateMat(3, 3, CV_64FC1);
  cvmSet(k, 0, 0, 0.0);
  cvmSet(k, 1, 0, 0.0);
  cvmSet(k, 2, 0, 1.0);

  CvMat *svdW = cvCreateMat(3, 3, CV_64FC1);
  CvMat *svdU = cvCreateMat(3, 3, CV_64FC1);
  CvMat *svdV = cvCreateMat(3, 3, CV_64FC1);
  cvmMulTransposed(F, matTmp, 0);
  cvSVD(matTmp, svdW, svdU, svdV);
  CvMat *e = cvCreateMat(3, 1, CV_64FC1);
  for(int i = 0; i < 3; i++) {
    cvmSet(e, i, 0, cvmGet(svdU, i, 2));
  }
  cvNormalize(e, e);

  cvmMulTransposed(F, matTmp, 1);
  cvSVD(matTmp, svdW, svdU, svdV);
  CvMat *ep = cvCreateMat(3, 1, CV_64FC1);
  for(int i = 0; i < 3; i++) {
    cvmSet(ep, i, 0, cvmGet(svdU, i, 2));
  }
  cvNormalize(ep, ep);

	cvmMul(F, k, vecTmp);
  double Fk  = cvNorm(vecTmp);
  double Fk2 = sq(Fk);
 
	cvTranspose(F, matTmp);
  cvmMul(matTmp, k, vecTmp);
  double Ftk  = cvNorm(vecTmp);
  double Ftk2 = sq(Ftk);

	cvmMulTransposed(F, matTmp, 0);
  cvmMul(matTmp, F, matTmp);
  cvmMul(matTmp, k, vecTmp);
  double kFFtFk = cvDotProduct(k, vecTmp);

  cvmMul(F, k, vecTmp);
  double kFk = cvDotProduct(k, vecTmp);

	cvCrossProduct(e, k, vecTmp);
  double ek2 = sq(cvNorm(vecTmp));

	cvCrossProduct(ep, k, vecTmp);
  double epk2 = sq(cvNorm(vecTmp));
  /* }}} */

  /* {{{ Ƚ */
  double condition = 0.1 * ((Fk > Ftk) ? Ftk : Fk) / f;
  if(fabs(kFk) < condition) {
    std::cout << "# ERROR : ǤϤޤ" << std::endl;
    f1 = f2 = f;
    return;
  }
  /* }}} */

  /* {{{ Bougnoux μη׻ */
  double xi  = (Fk2 - ((kFFtFk * epk2) / kFk)) / (epk2 * Ftk2 - sq(kFk));
  double eta = (Ftk2 - ((kFFtFk * ek2) / kFk)) / (ek2 * Fk2 - sq(kFk));
  /* }}} Bougnoux μη׻ */

  /* {{{Ѥ CvMat ʤɤγ */
  cvReleaseMat(&k);
  cvReleaseMat(&vecTmp);
  cvReleaseMat(&matTmp);
  cvReleaseMat(&svdW);
  cvReleaseMat(&svdU);
  cvReleaseMat(&svdV);
  cvReleaseMat(&e);
  cvReleaseMat(&ep);
	/* }}} */

  /* {{{ Υӽ */
  double inSqrt1 = 1.0 + xi;
  double inSqrt2 = 1.0 + eta;
  if(inSqrt1 < 0.0 || inSqrt2 < 0.0) {
    std::cout << "# ERROR : Υ" << std::endl;
    f1 = f2 = f;
  } else {
    f1 = f / sqrt(inSqrt1);
    f2 = f / sqrt(inSqrt2);
  }
  /* }}} */
}
