#include <iostream>
#include <fstream>
#include <cv.h>
#include "readFeature.h"


/**
 * @file readFeature.cc
 * @brief бǡɤ߹
 * @param filename бǡΥե̾
 * @param image1,image2 бǡǼ
 * @return бǡο
 * @author Kento YAMADA
 * @date 2009.09.18
 */
int readFeature(char *filename,
                CvMat **image1,
                CvMat **image2) {

	/* {{{ ե뤬뤫å */
  std::ifstream data_file(filename);  //!< бǡΥե
  if(!data_file) {
    std::cerr << "Unable to open " << filename << std::endl;
    return 0;
  }
  /* }}} */

  /* {{{ ե뤫Υǡɤ߹ߤȥǡΥ */
  int featureNum = 0;           //!< ħο
  std::string line;             //!< ŪʸǼʸ
  double x1[65536], y1[65536];  //!< ŪбɸǼ
  double x2[65536], y2[65536];  //!< ŪбɸǼ
  while(getline(data_file, line)) {
    if(sscanf(line.c_str(),
       "(%lf,%lf)--(%lf,%lf)",
       &x1[featureNum], &y1[featureNum],
       &x2[featureNum], &y2[featureNum]) == 4) {
      featureNum++;
    }
  }
  data_file.close();
  /* }}} */

	/* {{{ γݤȿͤ */
  *image1 = cvCreateMat(featureNum, 2, CV_64FC1);
  *image2 = cvCreateMat(featureNum, 2, CV_64FC1);
  for(int i = 0; i < featureNum; i++) {
    cvmSet((*image1), i, 0, x1[i]);
    cvmSet((*image1), i, 1, y1[i]);
    cvmSet((*image2), i, 0, x2[i]);
    cvmSet((*image2), i, 1, y2[i]);
  }
  /* }}} */

  return featureNum;
}
